{{quicktest.spin}}

CON
_CLKMODE = XTAL1 + PLL16x
_XINFREQ = 5_000_000

SERIAL_BAUD_RATE = 19_200
SERIAL_MODE = %0000_1000
QPOS = %00001_000
QSPD = %00010_000
CHFA = %00011_000
TRVL = %00100_000
CLRP = %00101_000
SREV = %00110_000
STXD = %00111_000
SMAX = %01000_000
SSRR = %01001_000
L_MOTOR_ID = %00000_001
R_MOTOR_ID = %00000_010
BOTH_MOTOR_ID = L_MOTOR_ID + R_MOTOR_ID
MAX_SPEED = 24
MAX_ACCELLERATION = 10
ARRIVAL_TOLERANCE = 10

L_MOTOR_HB25_PIN = 0
SERIAL_OUT_PIN = 1
VAR
  LONG ARRIVED
  LONG LOCATION
  LONG L_MOTOR_POSITION
  LONG COUNTER
  
OBJ
vp      : "Conduit"  'transfers data to/from PC
serial  : "Simple_Serial"   ' **** Change back to Simple_Serial

PUB MAIN

serial.init(SERIAL_OUT_PIN,SERIAL_OUT_PIN,SERIAL_BAUD_RATE) ' **** Change back to Simple_Serial
vp.config(string("var:ARRIVED(unit=v,f=x)"))
vp.config(string("var:LOCATION(unit=v,f=x)"))
vp.config(string("var:L_MOTOR_POSITION(unit=v,f=x)"))
vp.config(string("var:COUNTER(unit=v,f=x)"))
vp.share(@ARRIVED,@COUNTER)
delay (10000)
repeat
  LOCATION := 0
  serial.tx(CLRP+BOTH_MOTOR_ID)                       ' Clear the position on both motors, causing them to stop
  delay (1)
  serial.tx(TRVL+L_MOTOR_ID)                          ' Travel 1000 positions with Left motor
  delay (1)
  serial.tx(%00000011)
  delay (1)
  serial.tx(%11101000)
  delay (1)
  serial.tx(CHFA+L_MOTOR_ID)                          ' Check for arrival and send tolerance value
  delay (1)
  serial.tx(ARRIVAL_TOLERANCE)
'  serial.rxflush   ' **** Not in Simple_Serial
'  delay(1)   ' **** Don't use with Simple_Serial
  LOCATION := 1
  ARRIVED[0]:= serial.rx                                 ' See if we have arrived or not.  Loop until we have
  LOCATION := 2
  REPEAT UNTIL (ARRIVED[0] == $FF)
    serial.tx(QPOS+L_MOTOR_ID)
'    serial.rxflush   ' **** Not in Simple_Serial
'    delay (1)   ' **** Don't use with Simple_Serial
    L_MOTOR_POSITION[1] := serial.rx
    L_MOTOR_POSITION[0] := serial.rx
    delay (1)   ' **** Add delay here
    serial.tx(CHFA+L_MOTOR_ID)
    delay (1)
    serial.tx(ARRIVAL_TOLERANCE)
'    serial.rxflush   ' **** Not in Simple_Serial
'    delay (1)   ' **** Don't use with Simple_Serial
    COUNTER++
    ARRIVED[0] := serial.rx
  LOCATION := 3
  delay (10000)
  serial.tx(TRVL+L_MOTOR_ID)                          ' Travel -1000 positions with Left motor
  delay (1)
  serial.tx(%11111100)
  delay (1)
  serial.tx(%00011000)
  delay (1)
  serial.tx(CHFA+L_MOTOR_ID)
  delay (1)
  serial.tx(ARRIVAL_TOLERANCE)
' serial.rxflush   ' **** Not in Simple_Serial
' delay (1)   ' **** Don't use with Simple_Serial
  ARRIVED[0]:= serial.rx
  LOCATION := 4
  REPEAT UNTIL (ARRIVED[0] == $FF)
    delay (1)   ' **** Add delay here
    serial.tx(QPOS+L_MOTOR_ID)
' delay (1)   ' **** Don't use with Simple_Serial
    L_MOTOR_POSITION[1] := serial.rx
    L_MOTOR_POSITION[0] := serial.rx
    delay (1)   ' **** Add delay here
    serial.tx(CHFA+L_MOTOR_ID)
    delay (1)
    serial.tx(ARRIVAL_TOLERANCE)
'    serial.rxflush   ' **** Not in Simple_Serial
'    delay (1)   ' **** Don't use with Simple_Serial
    COUNTER++
    ARRIVED[0] := serial.rx

PUB delay (delay_time) | Time
REPEAT delay_time
  Time := cnt
  waitcnt((clkfreq/1000) + Time)    